import AbstractFactory from '../../../../di/src/factory/AbstractFactory.ts'
import {DependencyRequirement} from '../../../../di/src/type/DependencyRequirement.ts'
import {Collection} from '../../collection/Collection.ts'
import MemorySessionManager from './MemorySessionManager.ts'
import SessionManager from './SessionManager.ts'

// TODO support configurable session backends

export default class SessionManagerFactory extends AbstractFactory {
    constructor() {
        super({})
    }

    produce(dependencies: any[], parameters: any[]): any {
        return new MemorySessionManager()
    }

    match(something: any) {
        return something === SessionManager
    }

    get_dependency_keys(): Collection<DependencyRequirement> {
        return new Collection<DependencyRequirement>()
    }
}
