import {QueryResult} from './types.ts'

export class ConnectionNotReadyError extends Error {
    constructor(name = '') {
        super(`The connection ${name} is not ready and cannot execute queries.`)
    }
}

export abstract class Connection {

    constructor(
        public readonly name: string,
        public readonly config: any = {},
    ) {}

    public abstract async init(): Promise<void>
    public abstract async query(query: string): Promise<QueryResult> // TODO query result
    public abstract async close(): Promise<void>

}
